#!/usr/local/bin/perl 
#               -------------
#				   Links
#               -------------
#               Links Manager
#
#         File: rate.cgi
#  Description: Updates URL.DB with new rating and votes.
#       Author: Tawheed Kader
#        Email: webmaster@pcmi.net
#          Web: http://www.pcmi.net/mfc
#       : WWW:
#     Ƨ@: Jonas teng  Hc :tengcy@pcmail.com.tw
#      Version: 4.0a
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Tawheed Kader.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Tawheed Kader. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
#
#   Form Input: 
#       '$db_key'   = key number        # Send as form input the key name and key value
#									   # of the link you want to go to.
#       '$db_rating'= user's rating
#

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "admin/links.cfg";				# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";
    require "$db_lib_path/site_html.pl";
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
}

# ========================================================

eval { &main; };					        # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

sub main {
# --------------------------------------------------------
        local (%in) = &parse_form;
	my(@lines, $line_number, $visited, $output);
	my($id, $url, $title, $votes, $rating, $timestamp, @IP);

	$visited = 0;
	$line_number = 0;

	if($in{$db_key})
	{
		if($in{$db_rat})
		{
			$time = time();
			open(RATE, "<$db_rate_name") or &cgierr("unable to open rate index $db_rate_name. Reason: $!");
			@lines = <RATE>;
			close RATE;
			
			LINE: foreach $line (@lines)
			{
				if ($line =~ /^#/) { next LINE; }       # Skip comment lines.   
				if ($line =~ /^\s*$/) { next LINE; }    # Skip blank lines.
				chomp ($line);
				
				($id, $url, $title, $votes, $rating, $timestamp, @IP) = split (/\Q$db_delim\E/, $line);
				
				if($id eq $in{$db_key})
				{
					if (($time - $timestamp) > 21600) { @IP = (); }
					IP: foreach $IP (@IP) 
					{             
						if ($IP eq $ENV{'REMOTE_ADDR'})
						{
					    		$visited = 1;
					    		last IP;
						}
					}
					if($visited == 0)
					{
						push (@IP, $ENV{'REMOTE_ADDR'});
                                                if($votes == 0)
                                                {
                                                        $rating = $in{$db_rat};
                                                        $votes = 1;
                                                }
                                                else
                                                {                  
                                                        $rating = $rating * $votes + $in{$db_rat};
                                                        $votes = $votes + 1;
                                                        $rating = $rating / $votes * 10;
							$rating = int($rating) / 10;
                                                }
                                                $timestamp = $time;		
						&site_html_rating_form_success($id, $url, $title, $votes, $rating);
					}
				}
				$output .= "$id$db_delim$url$db_delim$title$db_delim$votes$db_delim$rating$db_delim$timestamp$db_delim";
				$output .= join ("$db_delim", @IP); 
				$output .= "\n";
				$line_number++;
			}
			open (RATE, ">$db_rate_name") or &cgierr("error in jump. unable to open rate index: $db_rate_name. Reason: $!");
			flock(RATE, $LOCK_EX) unless (!$db_use_flock);
			print RATE $output;
			close RATE;
			if($visited == 1)
			{
				&site_html_rating_form_cheat ($ENV{'REMOTE_ADDR'});
			}
		}
		else
		{
			open(RATE, "<$db_rate_name") or &cgierr("unable to open rate index $db_rate_name. Reason: $!");
			@lines = <RATE>;
			close RATE;
			
			LINE: foreach $line (@lines)
			{
				if ($line =~ /^#/) { next LINE; }       # Skip comment lines.   
				if ($line =~ /^\s*$/) { next LINE; }    # Skip blank lines.
				chomp ($line);
				
				($id, $url, $title, $votes, $rating, $timestamp, @IP) = split (/\Q$db_delim\E/, $line);
				
				if($id eq $in{$db_key})
				{
					&site_html_rating_form($id, $title);
				}
			}
		}
	}
	else
	{
		&site_html_rating_form_noid;
	}
}

