#!/usr/local/bin/perl
#               -------------
#				   Links
#               -------------
#               Links Manager
#
#         File: rates.cgi
#  Description: Shows Real-Time statistics of current ratings and votes.
#       Author: Tawheed Kader
#        Email: webmaster@pcmi.net
#          Web: http://www.pcmi.net/mfc
#        : WWW: 
#     Ƨ@ : Jonas teng  Hc :tengcy@pcmail.com.tw
#      Version: 4.0a
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Tawheed Kader.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Tawheed Kader. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
#
#
# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "admin/links.cfg";				# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";
    require "$db_lib_path/site_html.pl";
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
}

# ========================================================

eval { &main; };					        # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

sub main {
        &html_print_headers;
	if($db_rate_method == 1){&topx;} else {&percent;}
}

sub percent {
my($line, @lines, @popular_votes, @popular_rating, $cutoff_votes, $cutoff_rating);
my($output, $percent, $votp, $ratp, %vot, %rat);
my ($id, $url, $title, $votes, $rating, @rest);
my($i, $d);

open (URL, "<$db_rate_name") or &cgierr("unable to open rate index: $db_rate_name. Reason: $!");
@lines = <URL>;
close (URL);

LINE: foreach $line (@lines) 
{
	next LINE if ($line =~ /^#/);
	next LINE if ($line =~ /^\s*$/);
	chomp $line;
	($id, $url, $title, $votes, $rating, @rest) = split (/\Q$db_delim\E/, $line);
	push (@popular_votes, $votes);
	push (@popular_rating, $rating);
}   
	@popular_votes = sort { $b <=> $a } @popular_votes;
	$cutoff_votes = $popular_votes[int($db_rate_cutoff * $#popular_votes)];
	if ($cutoff_votes < 2) { $cutoff_votes = 2; }

	@popular_rating = sort { $b <=> $a } @popular_rating;
	$cutoff_rating = $popular_rating[int($db_rate_cutoff * $#popular_rating)];
	if ($cutoff_rating < 2) { $cutoff_rating = 2; }

LINE: foreach $line (@lines) 
{
	next LINE if ($line =~ /^#/);
	next LINE if ($line =~ /^\s*$/);
	chomp $line;
	($id, $url, $title, $votes, $rating, @rest) = split (/\Q$db_delim\E/, $line);
	if($votes >= $cutoff_votes)
	{
		$vot{$id} = $votes;
	}
	if($rating >= $cutoff_rating)
	{
		$rat{$id} = $rating;
	}
}
	@popular_votes = sort { $vot{$b} <=> $vot{$a} } keys %vot;
	@popular_rating = sort { $rat{$b} <=> $rat{$a} } keys %rat;
	
	for($i = 0; $i <= scalar(@popular_votes); $i++)
	{
		LINE: foreach $line (@lines) 
		{
			next LINE if ($line =~ /^#/);   # Skip Comment Lines.
			next LINE if ($line =~ /^\s*$/); # Skip Blank Lines.
			chomp $line;			# Remove new line char.
			($id, $url, $title, $vot, $rat, @rest) = &split_decode ($line);
			if(@popular_votes[$i] == $id)
			{
				$d = $i + 1;
				$votp .= site_html_rstat_listing($id, $url, $title, $vot, $rat, $d);
			}
			else
			{
				next LINE;
			}
		}
	}

	for($i = 0; $i <= scalar(@popular_rating); $i++)
	{
		LINE: foreach $line (@lines) 
		{
			next LINE if ($line =~ /^#/);   # Skip Comment Lines.
			next LINE if ($line =~ /^\s*$/); # Skip Blank Lines.
			chomp $line;			# Remove new line char.
			($id, $url, $title, $vot, $rat, @rest) = &split_decode ($line);
			if(@popular_rating[$i] == $id)
			{
				$d = $i + 1;
				$ratp .= site_html_rstat_listing($id, $url, $title, $vot, $rat, $d);
			}
			else
			{
				next LINE;
			}
		}
	}

	&site_html_rstat_show($votp, $ratp);
}
sub topx {
my(@lines, %rating, %votes, $id, $title, $url, $rat, $vot, @rest, $line);
my(@mylist);
my($i,$d, $output, $votp, $ratp);

open (URL, "<$db_rate_name") or &cgierr("unable to open rate index: $db_rate_name. Reason: $!");
@lines = <URL>;
close (URL);


	LINE: foreach $line (@lines) 
	{
		next LINE if ($line =~ /^#/);   # Skip Comment Lines.
		next LINE if ($line =~ /^\s*$/); # Skip Blank Lines.
		chomp $line;					# Remove new line char.
		($id, $url, $title, $vot, $rat, @rest) = &split_decode ($line);
		$rating{$id} = $rat;
		$votes{$id} = $vot;
	}   

	@mylist = sort { $votes{$b} <=> $votes{$a} } keys %votes;

	for($i = 0; $i <= $db_rate_topx; $i++)
	{
		LINE: foreach $line (@lines) 
		{
			next LINE if ($line =~ /^#/);   # Skip Comment Lines.
			next LINE if ($line =~ /^\s*$/); # Skip Blank Lines.
			chomp $line;			# Remove new line char.
			($id, $url, $title, $vot, $rat, @rest) = &split_decode ($line);
			if(@mylist[$i] == $id)
			{
				next LINE if($rat == 0 || $vot == 0);
				$d = $i + 1;
				$votp .= site_html_rstat_listing($id, $url, $title, $vot, $rat, $d);
			}
			else
			{
				next LINE;
			}			
		}   
	}

	@mylist = sort { $rating{$b} <=> $rating{$a} } keys %rating;
	for($i = 0; $i <= 10; $i++)
	{
		LINE: foreach $line (@lines) 
		{
			next LINE if ($line =~ /^#/);   # Skip Comment Lines.
			next LINE if ($line =~ /^\s*$/); # Skip Blank Lines.
			chomp $line;			# Remove new line char.
			($id, $url, $title, $vot, $rat, @rest) = &split_decode ($line);
			if(@mylist[$i] == $id)
			{
				next LINE if($rat == 0 || $vot == 0);
				$d = $i + 1;
				$ratp .= site_html_rstat_listing($id, $url, $title, $vot, $rat, $d);
			}
			else
			{
				next LINE;
			}			
		}   
	}
	&site_html_rstat_show($votp, $ratp);
}

