#!/usr/local/bin/perl
#			   -------------
#				  Links
#			   -------------
#			   Links Manager
#
#		Name: Review-It Mod
#		File: review.cgi
#  		Description: Displays a review of a Link 
#	   	Author: Steve Miles
#		Email: nsurfer@bellsouth.net
#		Web: http://www.adultjump.com/links/
#       : WWW:
#     Ƨ@: Jonas teng  Hc : tengcy@pcmail.com.tw
#
# COPYRIGHT NOTICE:
#
# The Review-It Mod is freeware for your use and modification.
#
# However, the Links 1.1 script is
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
#   Form Input: 
#	   '$db_key'   = key number		# Send as form input the key name and key value
#						# of the link you want to go to.
#
#   Setup:
#	   Make sure the require statement below points to the config file.	

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

	require "admin/links.cfg";			  # Change this to full path to links.cfg if you have problems.
	require "$db_lib_path/db.pl";
        require "$db_lib_path/site_html.pl";
};
if ($@) {
	print "Content-type: text/plain\n\n";
	print "Error including libraries: $@\n";
	print "Make sure they exist, permissions are set properly, and paths are set correctly.";
}

# ========================================================

eval { &main; };						 # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }	 # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

sub main {
# --------------------------------------------------------
	local (%in) = &parse_form;
	
	if ($in{$db_key}) {

# Link database stores a list link attributes.
		open  (LINK, "+>>$db_links_name")   or &cgierr("unable to open url index $db_url_name. Reason: $!");
		if ($db_use_flock) {
		   flock (LINK, 2) or &cgierr("unable to get exclusive lock. Reason: $!");
		}
		seek  (LINK, 0, 0);	  # rewind to beginning.

# Go through the Links database and find the link we want to go to.
		$visited = 0;
		LINE: while (<LINK>) {
			next LINE if (/^#/);		# Skip comment lines.
			next LINE if (/^\s*$/);		# Skip blank lines.
			$line = $_;
			chomp ($line);

# You will have to modify this next line to match the columns in your links.db file.
# You could use any variables here, just as long as $key and $review match up with the
# ID number and review columns in your database. For example, here the ID number is in the first
# column and the review is in the sixteenth column.
			($key, $title, $url, $date, $category, $description, $name, $email, $hits, $isNew, $isPopular, $votes, $rating, $promotion, $expire, $review, $revchoice) = split (/\Q$db_delim\E/, $line);
			$key = int($key);

# Find the key we are looking for..   

			if ($key == $in{$db_key}) {
			&site_html_review;
			exit;
			}
		}
	}
# If people put in a number not in the database or nothing at all...
	&site_html_review_noid;
}
